//
//  VCSModalViewController.swift
//  ViewControllerSikenjo
//
//  Created by narita on 2018/12/10.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class VCSModalViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    override func viewDidLoad()
    {
        super.viewDidLoad()        
    }

    // MARK: - action methods
    
    @IBAction func ok(_ sender: Any?)
    {        
        self.representedObject = self.model
        
        cancelOrOK = true
        self.dismiss(sender)
    }
    
    @IBAction func cancel(_ sender: Any?)
    {
        cancelOrOK = false
        self.dismiss(sender)
    }

    // MARK: - event handling methods

    override func prepare(for segue: NSStoryboardSegue, sender: Any?)
    {
        // インスペクターへ表示すべきデータを渡す
        if segue.identifier == "embededModal"
        {
            segue.destinationViewController?.representedObject = self.model
        }
    }
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    override var representedObject: Any?
    {
        didSet
        {
            if let theDict = self.representedObject as? NSDictionary
            {
                self.model = theDict.mutableCopy() as? NSMutableDictionary
            }
        }
    }
    
    @objc var model: NSMutableDictionary? = nil
    
    // falseがcancelでOKがtrue
    @objc var cancelOrOK: Bool = false
    
    // MARK: - Utility methods
}
